searchNodes=[{"doc":"A process that manages a gRPC channel. When ConnGRPC.Channel is started, it will create a gRPC connection, which can be fetched with ConnGRPC.Channel.get/1 . You can use this if you want to keep a persistent gRPC channel open to be reused in your application. Depending on the load, using a single channel for the entire application may become a bottleneck. In that case, see the ConnGRPC.Pool module, that allows creating a pool of channels. Module-based channel To implement a module-based gRPC channel, define a module that uses ConnGRPC.Channel . defmodule DemoChannel do use ConnGRPC.Channel , address : &quot;localhost:50051&quot; , opts : [ ] end Then, you can add the module to your application supervision tree. defmodule Demo.Application do use Application @impl true def start ( _type , _args ) do children = [ DemoChannel ] Supervisor . start_link ( children , strategy : :one_for_one , name : Demo.Supervisor ) end end To get the connection in your application, call: DemoChannel . get ( ) It'll return either {:ok, channel} or {:error, :not_connected} . Channel without module If you don't want to define for your channel, you can add ConnGRPC.Channel directly to your supervision tree and pass the options on the child spec. defmodule Demo.Application do use Application @impl true def start ( _type , _args ) do children = [ Supervisor . child_spec ( { ConnGRPC.Channel , name : :demo_channel , address : &quot;localhost:50051&quot; , opts : [ ] } , id : :demo_channel ) ] Supervisor . start_link ( children , strategy : :one_for_one , name : Demo.Supervisor ) end end To get the connection in your application, call: ConnGRPC.Channel . get_channel ( :demo_channel ) Options available For all options available, see start_link/1 . Telemetry ConnGRPC sends telemetry events. See telemetry.md .","ref":"ConnGRPC.Channel.html","title":"ConnGRPC.Channel","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ConnGRPC.Channel.html#child_spec/1","title":"ConnGRPC.Channel.child_spec/1","type":"function"},{"doc":"Returns the gRPC channel","ref":"ConnGRPC.Channel.html#get/2","title":"ConnGRPC.Channel.get/2","type":"function"},{"doc":"Starts and links process that keeps a persistent gRPC channel. Options :address - The gRPC server address. For more details, see GRPC.Stub.connect/2 :opts - Options for Elixir gRPC. For more details, see GRPC.Stub.connect/2 :name - A name to register the started process (see the :name option in GenServer.start_link/3 ) :backoff - Minimum and maximum exponential backoff intervals (default: [min: 1000, max: 30_000] ) :backoff_module - Backoff module to be used (default: ConnGRPC.Backoff.Exponential ). If you'd like to implement your own backoff, see the ConnGRPC.Backoff behavior. :debug - Write debug logs (default: false ) :on_connect - Function to run on connect (0-arity) :on_disconnect - Function to run on disconnect (0-arity) :grpc_stub - GRPC stub module that will receive the connect/2 call (default: GRPC.Stub )","ref":"ConnGRPC.Channel.html#start_link/1","title":"ConnGRPC.Channel.start_link/1","type":"function"},{"doc":"A process that manages a pool of persistent gRPC channels. When ConnGRPC.Pool is started, it will start a pool of pre-connected channels. You can then fetch an individual channel from it by calling ConnGRPC.Pool.get_channel/1 , which uses round-robin to determine the channel returned. ConnGRPC.Pool doesn't implement any checkout mechanism and acts as a routing pool, or a simple load balancer. The reason checkout is not implemented is because gRPC allows making multiple requests in parallel in a single channel, so we don't need to lock the channel to a specific process while it's being used. Module-based pool To implement a module-based gRPC pool, define a module that uses ConnGRPC.Pool . defmodule DemoPool do use ConnGRPC.Pool , pool_size : 5 , channel : [ address : &quot;localhost:50051&quot; , opts : [ ] ] end The format of address and opts is the same used by GRPC.Stub.connect/2 Then, you can add the module to your application supervision tree. defmodule Demo.Application do use Application @impl true def start ( _type , _args ) do children = [ DemoPool ] Supervisor . start_link ( children , strategy : :one_for_one , name : Demo.Supervisor ) end end To get a connection from the pool in your application, call: DemoPool . get_channel ( ) It'll return either {:ok, channel} or {:error, :not_connected} . Pool without module If you don't want to define a module for your pool, you can add ConnGRPC.Pool directly to your supervision tree and pass the options on the child spec. defmodule Demo.Application do use Application @impl true def start ( _type , _args ) do children = [ Supervisor . child_spec ( { ConnGRPC.Pool , name : :demo_pool , pool_size : 5 , channel : [ address : &quot;localhost:50051&quot; , opts : [ ] ] } , id : :demo_pool ) ] Supervisor . start_link ( children , strategy : :one_for_one , name : Demo.Supervisor ) end end The format of address and opts is the same used by GRPC.Stub.connect/2 To get a connection from the pool in your application, call: ConnGRPC.Pool . get_channel ( :demo_pool ) Options available For all options available, see start_link/1 . Telemetry ConnGRPC sends telemetry events. See telemetry.md .","ref":"ConnGRPC.Pool.html","title":"ConnGRPC.Pool","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ConnGRPC.Pool.html#child_spec/1","title":"ConnGRPC.Pool.child_spec/1","type":"function"},{"doc":"Returns all pids on the pool","ref":"ConnGRPC.Pool.html#get_all_pids/1","title":"ConnGRPC.Pool.get_all_pids/1","type":"function"},{"doc":"Returns a gRPC channel from the pool","ref":"ConnGRPC.Pool.html#get_channel/1","title":"ConnGRPC.Pool.get_channel/1","type":"function"},{"doc":"Starts and links supervisor that keeps a pool of gRPC channels. Options :name - A name to register the started process (see the :name option in GenServer.start_link/3 ) :pool_size - The size of the channel pool :channel - Channel configuration, such as address, connection options, backoff, and callbacks. For all options, see ConnGRPC.Channel.start_link/1","ref":"ConnGRPC.Pool.html#start_link/1","title":"ConnGRPC.Pool.start_link/1","type":"function"},{"doc":"Behaviour for implementing custom backoff.","ref":"ConnGRPC.Backoff.html","title":"ConnGRPC.Backoff","type":"behaviour"},{"doc":"Generate backoff delay and new state. This is called each time that we fail to connect.","ref":"ConnGRPC.Backoff.html#c:backoff/1","title":"ConnGRPC.Backoff.backoff/1","type":"callback"},{"doc":"Initializes the backoff state. This is called when the channel process is started.","ref":"ConnGRPC.Backoff.html#c:new/1","title":"ConnGRPC.Backoff.new/1","type":"callback"},{"doc":"Reset backoff state. This is called when connecting succeeds.","ref":"ConnGRPC.Backoff.html#c:reset/1","title":"ConnGRPC.Backoff.reset/1","type":"callback"},{"doc":"Exponential backoff with jitter. This is the default retry backoff mechanism used by ConnGRPC.","ref":"ConnGRPC.Backoff.Exponential.html","title":"ConnGRPC.Backoff.Exponential","type":"module"},{"doc":"ConnGRPC allows you to keep persistent channels, and use channel pools with gRPC Elixir .","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Add conn_grpc to your list of dependencies: def deps do [ { :conn_grpc , &quot;~&gt; 0.1&quot; } , # You also need to have gRPC Elixir installed { :grpc , &quot;~&gt; 0.5&quot; } ] end","ref":"overview.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"You can use ConnGRPC with a pool of persistent channels, or with a single persistent channel. Channel pools Define a module that uses ConnGRPC.Pool . defmodule DemoPool do use ConnGRPC.Pool , pool_size : 5 , channel : [ address : &quot;localhost:50051&quot; , opts : [ ] ] end Then add DemoPool to your supervision tree, and call get_channel/0 from anywhere in your application to get a channel connection: { :ok , channel } = DemoPool . get_channel ( ) Each time get_channel is called, a different channel from your pool will be returned using round-robin distribution. For more info, see ConnGRPC.Pool . Single channel For a single persistent channel, define a module that uses ConnGRPC.Channel . defmodule DemoChannel do use ConnGRPC.Channel , address : &quot;localhost:50051&quot; , opts : [ ] end Then add DemoChannel to your supervision tree, and call get/0 from anywhere in your application to get your channel connection: { :ok , channel } = DemoChannel . get ( ) Depending on the load, using a single channel for the entire application may become a bottleneck. In that case, use the ConnGRPC.Pool module, that creates a pool of channels. For more info, see ConnGRPC.Channel .","ref":"overview.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added ConnGRPC.Channel module ConnGRPC.Pool module","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"ConnGRPC sends telemetry events. Call :telemetry.attach/4 or :telemetry.attach_many/4 to attach your handler function to any of the following events:","ref":"telemetry.html","title":"Telemetry","type":"extras"},{"doc":"[:conn_grpc, :channel, :get] : reports the duration of the call to ConnGRPC.Channel.get/1 . If it's taking too long, the channel process is overwhelmed with messages, and increasing pool size may help. [:conn_grpc, :channel, :connected] : reports a successful connection, and how long it took to establish the connection [:conn_grpc, :channel, :connection_failed] : reports a failed connection, and how long it took trying to establish the connection [:conn_grpc, :channel, :disconnected] : reports a disconnection, and how long the connection stayed up","ref":"telemetry.html#channel-events","title":"Telemetry - Channel events","type":"extras"},{"doc":"[:conn_grpc, :pool, :get_channel] : reports the duration of the call to ConnGRPC.Pool.get_channel/1 . [:conn_grpc, :pool, :status] : reports the pool status, with the expected size (fixed pool size) and current size (amount of channels currently on the pool). This event is reported periodically.","ref":"telemetry.html#pool-events","title":"Telemetry - Pool events","type":"extras"}]